# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_cluster`](#dsc_cluster): The DSC Cluster resource type. Automatically generated from version 2.1.0
* [`dsc_clusterdisk`](#dsc_clusterdisk): The DSC ClusterDisk resource type. Automatically generated from version 2.1.0
* [`dsc_clusteripaddress`](#dsc_clusteripaddress): The DSC ClusterIPAddress resource type. Automatically generated from version 2.1.0
* [`dsc_clusternetwork`](#dsc_clusternetwork): The DSC ClusterNetwork resource type. Automatically generated from version 2.1.0
* [`dsc_clusterpreferredowner`](#dsc_clusterpreferredowner): The DSC ClusterPreferredOwner resource type. Automatically generated from version 2.1.0
* [`dsc_clusterproperty`](#dsc_clusterproperty): The DSC ClusterProperty resource type. Automatically generated from version 2.1.0
* [`dsc_clusterquorum`](#dsc_clusterquorum): The DSC ClusterQuorum resource type. Automatically generated from version 2.1.0
* [`dsc_waitforcluster`](#dsc_waitforcluster): The DSC WaitForCluster resource type. Automatically generated from version 2.1.0

## Resource types

### <a name="dsc_cluster"></a>`dsc_cluster`

The DSC Cluster resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_cluster` type.

##### `dsc_ignorenetwork`

Data type: `Optional[Array[String]]`

One or more networks to ignore when creating the cluster. Only networks using Static IP can be ignored, networks that are assigned an IP address through DHCP cannot be ignored, and are added for cluster communication. To remove networks assigned an IP address through DHCP use the resource ClusterNetwork to change the role of the network. This parameter is only used during the creation of the cluster and is not monitored after.

##### `dsc_keepdownednodesincluster`

Data type: `Optional[Boolean]`

Switch controlling whether or not to evict cluster nodes in a down state from the cluster. Default value is `$false`.

##### `dsc_staticipaddress`

Data type: `Optional[String]`

The static IP address of the failover cluster. If this is not specified then the IP address will be assigned from a DHCP.

#### Parameters

The following parameters are available in the `dsc_cluster` type.

* [`dsc_domainadministratorcredential`](#-dsc_cluster--dsc_domainadministratorcredential)
* [`dsc_name`](#-dsc_cluster--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_cluster--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_cluster--dsc_timeout)
* [`name`](#-dsc_cluster--name)
* [`validation_mode`](#-dsc_cluster--validation_mode)

##### <a name="-dsc_cluster--dsc_domainadministratorcredential"></a>`dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential used to create the failover cluster in Active Directory. If this is not specified then the cluster computer
object must have been prestaged as per the
[documentation](https://docs.microsoft.com/en-us/windows-server/failover-clustering/prestage-cluster-adds). If
`PsDscRunAsCredential` is used, then that account must have been granted Full Control over the Cluster Name Object in
Active Directory. Otherwise the Computer Account must have been granted Full Control over the Cluster Name Object in
Active Directory.

##### <a name="-dsc_cluster--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the failover cluster.

##### <a name="-dsc_cluster--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_cluster--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_cluster--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_cluster--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_clusterdisk"></a>`dsc_clusterdisk`

The DSC ClusterDisk resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_clusterdisk` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Define if the cluster disk should be added (Present) or removed (Absent). Default value is `'Present'`.

##### `dsc_label`

Data type: `Optional[String]`

The disk label that should be assigned to the disk on the Failover Cluster disk resource.

#### Parameters

The following parameters are available in the `dsc_clusterdisk` type.

* [`dsc_number`](#-dsc_clusterdisk--dsc_number)
* [`dsc_psdscrunascredential`](#-dsc_clusterdisk--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_clusterdisk--dsc_timeout)
* [`name`](#-dsc_clusterdisk--name)
* [`validation_mode`](#-dsc_clusterdisk--validation_mode)

##### <a name="-dsc_clusterdisk--dsc_number"></a>`dsc_number`

namevar

Data type: `String`

The disk number of the cluster disk.

##### <a name="-dsc_clusterdisk--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_clusterdisk--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_clusterdisk--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_clusterdisk--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_clusteripaddress"></a>`dsc_clusteripaddress`

The DSC ClusterIPAddress resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_clusteripaddress` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Enforce whether the IP address is present or absent from the Failover Cluster

#### Parameters

The following parameters are available in the `dsc_clusteripaddress` type.

* [`dsc_addressmask`](#-dsc_clusteripaddress--dsc_addressmask)
* [`dsc_ipaddress`](#-dsc_clusteripaddress--dsc_ipaddress)
* [`dsc_psdscrunascredential`](#-dsc_clusteripaddress--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_clusteripaddress--dsc_timeout)
* [`name`](#-dsc_clusteripaddress--name)
* [`validation_mode`](#-dsc_clusteripaddress--validation_mode)

##### <a name="-dsc_clusteripaddress--dsc_addressmask"></a>`dsc_addressmask`

namevar

Data type: `String`

The address mask for the IP address in the format '255.255.255.0'.

##### <a name="-dsc_clusteripaddress--dsc_ipaddress"></a>`dsc_ipaddress`

namevar

Data type: `String`

IP address to add or remove from the Failover Cluster

##### <a name="-dsc_clusteripaddress--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_clusteripaddress--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_clusteripaddress--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_clusteripaddress--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_clusternetwork"></a>`dsc_clusternetwork`

The DSC ClusterNetwork resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_clusternetwork` type.

##### `dsc_metric`

Data type: `Optional[String]`

The metric number for the cluster network. If the cluster network metric number is not in desired state it will be changed to match this metric number.

##### `dsc_name`

Data type: `Optional[String]`

The name of the cluster network. If the cluster network name is not in desired state it will be renamed to match this name.

##### `dsc_role`

Data type: `Optional[Enum['0', '1', '3']]`

The role of the cluster network. If the cluster network role is not in desired state it will change to match this role.

#### Parameters

The following parameters are available in the `dsc_clusternetwork` type.

* [`dsc_address`](#-dsc_clusternetwork--dsc_address)
* [`dsc_addressmask`](#-dsc_clusternetwork--dsc_addressmask)
* [`dsc_psdscrunascredential`](#-dsc_clusternetwork--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_clusternetwork--dsc_timeout)
* [`name`](#-dsc_clusternetwork--name)
* [`validation_mode`](#-dsc_clusternetwork--validation_mode)

##### <a name="-dsc_clusternetwork--dsc_address"></a>`dsc_address`

namevar

Data type: `String`

The address for the cluster network in the format `'10.0.0.0'`.

##### <a name="-dsc_clusternetwork--dsc_addressmask"></a>`dsc_addressmask`

namevar

Data type: `String`

The address mask for the cluster network in the format `'255.255.255.0'`.

##### <a name="-dsc_clusternetwork--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_clusternetwork--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_clusternetwork--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_clusternetwork--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_clusterpreferredowner"></a>`dsc_clusterpreferredowner`

The DSC ClusterPreferredOwner resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_clusterpreferredowner` type.

##### `dsc_clusterresources`

Data type: `Optional[Array[String]]`

The resources to set preferred owners on.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

If the preferred owners should be present or absent. Default value is `'Present'`.

##### `dsc_nodes`

Data type: `Array[String]`

The nodes to set as owners.

#### Parameters

The following parameters are available in the `dsc_clusterpreferredowner` type.

* [`dsc_clustergroup`](#-dsc_clusterpreferredowner--dsc_clustergroup)
* [`dsc_clustername`](#-dsc_clusterpreferredowner--dsc_clustername)
* [`dsc_psdscrunascredential`](#-dsc_clusterpreferredowner--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_clusterpreferredowner--dsc_timeout)
* [`name`](#-dsc_clusterpreferredowner--name)
* [`validation_mode`](#-dsc_clusterpreferredowner--validation_mode)

##### <a name="-dsc_clusterpreferredowner--dsc_clustergroup"></a>`dsc_clustergroup`

namevar

Data type: `String`

Name of the cluster group.

##### <a name="-dsc_clusterpreferredowner--dsc_clustername"></a>`dsc_clustername`

namevar

Data type: `String`

Name of the cluster.

##### <a name="-dsc_clusterpreferredowner--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_clusterpreferredowner--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_clusterpreferredowner--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_clusterpreferredowner--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_clusterproperty"></a>`dsc_clusterproperty`

The DSC ClusterProperty resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_clusterproperty` type.

##### `dsc_addevictdelay`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how many seconds after a node is evicted that the failover cluster service will wait before adding a new node.

##### `dsc_blockcachesize`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the size of the Cluster Shared Volume Memory Cache in MB.

##### `dsc_clusterloglevel`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the level of cluster logging.

##### `dsc_clusterlogsize`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the maximum size of the cluster log files on each of the nodes.

##### `dsc_crosssitedelay`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the time interval, in milliseconds, that the cluster network driver waits between sending Cluster Service heartbeats across sites.

##### `dsc_crosssitethreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Controls how many Cluster Service heartbeats that can be missed across sites before it determines that Cluster Service has stopped responding.

##### `dsc_crosssubnetdelay`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the time interval, in milliseconds, that the cluster network driver waits between sending Cluster Service heartbeats across subnets.

##### `dsc_crosssubnetthreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Controls how many Cluster Service heartbeats that can be missed across subnets before it determines that Cluster Service has stopped responding.

##### `dsc_databasereadwritemode`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the read/write mode for the cluster database.

##### `dsc_defaultnetworkrole`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the role that the cluster automatically assigns to any newly discovered or created network.

##### `dsc_description`

Data type: `Optional[String]`

Stores administrative comments about the cluster.

##### `dsc_drainonshutdown`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies whether to enable Node Drain for a cluster.

##### `dsc_dynamicquorum`

Data type: `Optional[Integer[0, 4294967295]]`

Enables the cluster to change the required number of nodes that need to participate in quorum when nodes shut down or crash.

##### `dsc_netftipsecenabled`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies whether Internet Protocol Security (IPSec) encryption is enabled for inter-node cluster communication.

##### `dsc_preferredsite`

Data type: `Optional[String]`

Specifies the preferred site for a site-aware cluster.

##### `dsc_quarantineduration`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the quarantine duration for a node, in seconds.

##### `dsc_quarantinethreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the quarantine threshold for a node, in minutes.

##### `dsc_samesubnetdelay`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the delay, in milliseconds, between netft heartbeats.

##### `dsc_samesubnetthreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Controls how many heartbeats can be missed on the same subnet before the route is declared as unreachable.

##### `dsc_shutdowntimeoutinminutes`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how many minutes after a system shutdown is initiated that the failover cluster service will wait for resources to go offline.

#### Parameters

The following parameters are available in the `dsc_clusterproperty` type.

* [`dsc_name`](#-dsc_clusterproperty--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_clusterproperty--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_clusterproperty--dsc_timeout)
* [`name`](#-dsc_clusterproperty--name)
* [`validation_mode`](#-dsc_clusterproperty--validation_mode)

##### <a name="-dsc_clusterproperty--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the cluster.

##### <a name="-dsc_clusterproperty--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_clusterproperty--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_clusterproperty--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_clusterproperty--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_clusterquorum"></a>`dsc_clusterquorum`

The DSC ClusterQuorum resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_clusterquorum` type.

##### `dsc_resource`

Data type: `Optional[String]`

The name of the disk, file share or Azure storage account resource to use as witness. This parameter is optional if the quorum type is set to `'NodeMajority'`.

##### `dsc_storageaccountaccesskey`

Data type: `Optional[String]`

The access key of the Azure storage account to use as witness. This parameter is required if the quorum type is set to `'NodeAndCloudMajority'`. **NOTE!** The key is currently not updated if the resource is already set.

##### `dsc_type`

Data type: `Optional[Enum['NodeMajority', 'nodemajority', 'NodeAndDiskMajority', 'nodeanddiskmajority', 'NodeAndFileShareMajority', 'nodeandfilesharemajority', 'NodeAndCloudMajority', 'nodeandcloudmajority', 'DiskOnly', 'diskonly']]`

Quorum type to use.

#### Parameters

The following parameters are available in the `dsc_clusterquorum` type.

* [`dsc_issingleinstance`](#-dsc_clusterquorum--dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#-dsc_clusterquorum--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_clusterquorum--dsc_timeout)
* [`name`](#-dsc_clusterquorum--name)
* [`validation_mode`](#-dsc_clusterquorum--validation_mode)

##### <a name="-dsc_clusterquorum--dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes', 'yes']`

Specifies the resource is a single instance, the value must be `'Yes'`.

##### <a name="-dsc_clusterquorum--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_clusterquorum--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_clusterquorum--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_clusterquorum--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_waitforcluster"></a>`dsc_waitforcluster`

The DSC WaitForCluster resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_waitforcluster` type.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum number of retries to check for cluster existence. Default value is `50` (retries).

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Interval to check for cluster existence. Default values is `10` (seconds).

#### Parameters

The following parameters are available in the `dsc_waitforcluster` type.

* [`dsc_name`](#-dsc_waitforcluster--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_waitforcluster--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_waitforcluster--dsc_timeout)
* [`name`](#-dsc_waitforcluster--name)
* [`validation_mode`](#-dsc_waitforcluster--validation_mode)

##### <a name="-dsc_waitforcluster--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the cluster to wait for.

##### <a name="-dsc_waitforcluster--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_waitforcluster--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_waitforcluster--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_waitforcluster--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

